"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .arrivalnoticefields import ArrivalNoticeFields, ArrivalNoticeFieldsTypedDict
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ArrivalNoticeValidationErrorsTypedDict(TypedDict):
    message: str


class ArrivalNoticeValidationErrors(BaseModel):
    message: str


class ArrivalNoticeTypedDict(TypedDict):
    r"""Extracted Arrival Notice Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[ArrivalNoticeFieldsTypedDict]
    r"""Fields extracted from an arrival notice"""
    validation_errors: NotRequired[List[ArrivalNoticeValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class ArrivalNotice(BaseModel):
    r"""Extracted Arrival Notice Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[ArrivalNoticeFields] = None
    r"""Fields extracted from an arrival notice"""

    validation_errors: Annotated[
        Optional[List[ArrivalNoticeValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
