"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .basiccontractfields import BasicContractFields, BasicContractFieldsTypedDict
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BasicContractValidationErrorsTypedDict(TypedDict):
    message: str


class BasicContractValidationErrors(BaseModel):
    message: str


class BasicContractTypedDict(TypedDict):
    r"""Extracted Basic Contract Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[BasicContractFieldsTypedDict]
    r"""Fields extracted from a basic contract"""
    validation_errors: NotRequired[List[BasicContractValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class BasicContract(BaseModel):
    r"""Extracted Basic Contract Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[BasicContractFields] = None
    r"""Fields extracted from a basic contract"""

    validation_errors: Annotated[
        Optional[List[BasicContractValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
