"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .brokeragestatementfields import (
    BrokerageStatementFields,
    BrokerageStatementFieldsTypedDict,
)
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BrokerageStatementValidationErrorsTypedDict(TypedDict):
    message: str


class BrokerageStatementValidationErrors(BaseModel):
    message: str


class BrokerageStatementTypedDict(TypedDict):
    r"""Extracted Brokerage Statement Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[BrokerageStatementFieldsTypedDict]
    r"""Fields extracted from a brokerage statement"""
    validation_errors: NotRequired[List[BrokerageStatementValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class BrokerageStatement(BaseModel):
    r"""Extracted Brokerage Statement Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[BrokerageStatementFields] = None
    r"""Fields extracted from a brokerage statement"""

    validation_errors: Annotated[
        Optional[List[BrokerageStatementValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
