"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .certificateoforiginfields import (
    CertificateOfOriginFields,
    CertificateOfOriginFieldsTypedDict,
)
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CertificateOfOriginValidationErrorsTypedDict(TypedDict):
    message: str


class CertificateOfOriginValidationErrors(BaseModel):
    message: str


class CertificateOfOriginTypedDict(TypedDict):
    r"""Extracted Certificate Of Origin Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[CertificateOfOriginFieldsTypedDict]
    r"""Fields extracted from a certificate of origin"""
    validation_errors: NotRequired[List[CertificateOfOriginValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class CertificateOfOrigin(BaseModel):
    r"""Extracted Certificate Of Origin Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[CertificateOfOriginFields] = None
    r"""Fields extracted from a certificate of origin"""

    validation_errors: Annotated[
        Optional[List[CertificateOfOriginValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
