"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .customsdeclarationfields import (
    CustomsDeclarationFields,
    CustomsDeclarationFieldsTypedDict,
)
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CustomsDeclarationValidationErrorsTypedDict(TypedDict):
    message: str


class CustomsDeclarationValidationErrors(BaseModel):
    message: str


class CustomsDeclarationTypedDict(TypedDict):
    r"""Extracted Customs Declaration Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[CustomsDeclarationFieldsTypedDict]
    r"""Fields extracted from a customs declaration"""
    validation_errors: NotRequired[List[CustomsDeclarationValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class CustomsDeclaration(BaseModel):
    r"""Extracted Customs Declaration Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[CustomsDeclarationFields] = None
    r"""Fields extracted from a customs declaration"""

    validation_errors: Annotated[
        Optional[List[CustomsDeclarationValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
