"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .deliverynotefields import DeliveryNoteFields, DeliveryNoteFieldsTypedDict
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class DeliveryNoteValidationErrorsTypedDict(TypedDict):
    message: str


class DeliveryNoteValidationErrors(BaseModel):
    message: str


class DeliveryNoteTypedDict(TypedDict):
    r"""Extracted Delivery Note Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[DeliveryNoteFieldsTypedDict]
    r"""Fields extracted from a delivery note"""
    validation_errors: NotRequired[List[DeliveryNoteValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class DeliveryNote(BaseModel):
    r"""Extracted Delivery Note Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[DeliveryNoteFields] = None
    r"""Fields extracted from a delivery note"""

    validation_errors: Annotated[
        Optional[List[DeliveryNoteValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
