"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .internationalconsignmentnotefields import (
    InternationalConsignmentNoteFields,
    InternationalConsignmentNoteFieldsTypedDict,
)
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class InternationalConsignmentNoteValidationErrorsTypedDict(TypedDict):
    message: str


class InternationalConsignmentNoteValidationErrors(BaseModel):
    message: str


class InternationalConsignmentNoteTypedDict(TypedDict):
    r"""Extracted International Consignment Note Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[InternationalConsignmentNoteFieldsTypedDict]
    r"""Fields extracted from an international consignment note"""
    validation_errors: NotRequired[
        List[InternationalConsignmentNoteValidationErrorsTypedDict]
    ]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class InternationalConsignmentNote(BaseModel):
    r"""Extracted International Consignment Note Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[InternationalConsignmentNoteFields] = None
    r"""Fields extracted from an international consignment note"""

    validation_errors: Annotated[
        Optional[List[InternationalConsignmentNoteValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
