"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .packinglistfields import PackingListFields, PackingListFieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PackingListValidationErrorsTypedDict(TypedDict):
    message: str


class PackingListValidationErrors(BaseModel):
    message: str


class PackingListTypedDict(TypedDict):
    r"""Extracted Packing List Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[PackingListFieldsTypedDict]
    r"""Fields extracted from a packing list"""
    validation_errors: NotRequired[List[PackingListValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class PackingList(BaseModel):
    r"""Extracted Packing List Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[PackingListFields] = None
    r"""Fields extracted from a packing list"""

    validation_errors: Annotated[
        Optional[List[PackingListValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
