"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .personalearningsstatementfields import (
    PersonalEarningsStatementFields,
    PersonalEarningsStatementFieldsTypedDict,
)
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PersonalEarningsStatementValidationErrorsTypedDict(TypedDict):
    message: str


class PersonalEarningsStatementValidationErrors(BaseModel):
    message: str


class PersonalEarningsStatementTypedDict(TypedDict):
    r"""Extracted Personal Earnings Statement Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[PersonalEarningsStatementFieldsTypedDict]
    r"""Fields extracted from a personal earnings statement"""
    validation_errors: NotRequired[
        List[PersonalEarningsStatementValidationErrorsTypedDict]
    ]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class PersonalEarningsStatement(BaseModel):
    r"""Extracted Personal Earnings Statement Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[PersonalEarningsStatementFields] = None
    r"""Fields extracted from a personal earnings statement"""

    validation_errors: Annotated[
        Optional[List[PersonalEarningsStatementValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
