"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from abbyy_document_ai import utils
from abbyy_document_ai.types import BaseModel
from typing import Optional


class ProblemDetailData(BaseModel):
    type: str
    r"""A URI reference that identifies the problem type."""

    title: str
    r"""A short, human-readable summary of the problem type."""

    status: float
    r"""The HTTP status code generated by the origin server for this occurrence of the problem."""

    detail: str
    r"""A human-readable explanation specific to this occurrence of the problem."""

    instance: Optional[str] = None
    r"""The URI that identifies the specific occurrence of the problem."""


class ProblemDetail(Exception):
    r"""Our error response format is based off of [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html).  The type property contains a URI reference that identifies the error.  Changes to the type value are considered a breaking change so the type property can be used like a traditional error code for programmatic checking of error type."""

    data: ProblemDetailData

    def __init__(self, data: ProblemDetailData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, ProblemDetailData)
