"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .remittanceadvicefields import (
    RemittanceAdviceFields,
    RemittanceAdviceFieldsTypedDict,
)
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class RemittanceAdviceValidationErrorsTypedDict(TypedDict):
    message: str


class RemittanceAdviceValidationErrors(BaseModel):
    message: str


class RemittanceAdviceTypedDict(TypedDict):
    r"""Extracted Remittance Advice Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[RemittanceAdviceFieldsTypedDict]
    r"""Fields extracted from a remittance advice"""
    validation_errors: NotRequired[List[RemittanceAdviceValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class RemittanceAdvice(BaseModel):
    r"""Extracted Remittance Advice Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[RemittanceAdviceFields] = None
    r"""Fields extracted from a remittance advice"""

    validation_errors: Annotated[
        Optional[List[RemittanceAdviceValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
