"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .usform1040fields import USForm1040Fields, USForm1040FieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UsForm1040ValidationErrorsTypedDict(TypedDict):
    message: str


class UsForm1040ValidationErrors(BaseModel):
    message: str


class UsForm1040TypedDict(TypedDict):
    r"""Extracted US Form 1040 Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[USForm1040FieldsTypedDict]
    r"""Fields extracted from a US Form 1040"""
    validation_errors: NotRequired[List[UsForm1040ValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class UsForm1040(BaseModel):
    r"""Extracted US Form 1040 Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[USForm1040Fields] = None
    r"""Fields extracted from a US Form 1040"""

    validation_errors: Annotated[
        Optional[List[UsForm1040ValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
