"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .usformw2fields import USFormW2Fields, USFormW2FieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UsFormW2ValidationErrorsTypedDict(TypedDict):
    message: str


class UsFormW2ValidationErrors(BaseModel):
    message: str


class UsFormW2TypedDict(TypedDict):
    r"""Extracted US Form W2 Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[USFormW2FieldsTypedDict]
    r"""Fields extracted from a US Form W-2"""
    validation_errors: NotRequired[List[UsFormW2ValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class UsFormW2(BaseModel):
    r"""Extracted US Form W2 Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[USFormW2Fields] = None
    r"""Fields extracted from a US Form W-2"""

    validation_errors: Annotated[
        Optional[List[UsFormW2ValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
