"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .utilitybillfields import UtilityBillFields, UtilityBillFieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UtilityBillValidationErrorsTypedDict(TypedDict):
    message: str


class UtilityBillValidationErrors(BaseModel):
    message: str


class UtilityBillTypedDict(TypedDict):
    r"""Extracted Utility Bill Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[UtilityBillFieldsTypedDict]
    r"""Fields extracted from a utility bill"""
    validation_errors: NotRequired[List[UtilityBillValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class UtilityBill(BaseModel):
    r"""Extracted Utility Bill Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[UtilityBillFields] = None
    r"""Fields extracted from a utility bill"""

    validation_errors: Annotated[
        Optional[List[UtilityBillValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
